[
    [ "Contributing to DynamoRIO", "page_contributing.html", {% include_relative page_contributing.js %} ],
    [ "Building from Source", "page_building.html", [
      [ "Quick Start", "page_building.html#autotoc_md73", [
        [ "Linux", "page_building.html#autotoc_md74", null ],
        [ "Windows", "page_building.html#autotoc_md75", null ],
        [ "Debug Build", "page_building.html#autotoc_md76", null ],
        [ "Installing from a Local Build", "page_building.html#autotoc_md77", null ]
      ] ],
      [ "Details for Building on Linux", "page_building.html#sec_build_linux", [
        [ "Setup for Simultaneous 64-bit and 32-bit Building", "page_building.html#autotoc_md79", null ],
        [ "Building 32-bit DynamoRIO on 64-bit Linux", "page_building.html#autotoc_md80", null ],
        [ "Useful Configuration Options", "page_building.html#autotoc_md81", null ],
        [ "Cross-Compiling for ARM on Linux", "page_building.html#autotoc_md83", null ],
        [ "Cross-Compiling for ARM Android", "page_building.html#autotoc_md85", null ],
        [ "Building AArchXX Tooling to Execute on x86", "page_building.html#sec_aarch_on_x86", null ]
      ] ],
      [ "Details for Building on Windows", "page_building.html#autotoc_md88", [
        [ "Compiler", "page_building.html#autotoc_md89", null ],
        [ "CMake", "page_building.html#autotoc_md90", null ],
        [ "Other Tools", "page_building.html#autotoc_md91", null ],
        [ "Using Cygwin", "page_building.html#autotoc_md92", null ]
      ] ],
      [ "Details of Building with CMake", "page_building.html#sec_cmake", [
        [ "Components", "page_building.html#autotoc_md94", null ],
        [ "Configuring Your Build", "page_building.html#autotoc_md95", null ],
        [ "Building", "page_building.html#autotoc_md96", null ],
        [ "An Example of Building DynamoRIO in Windows-XP 64bit in cmd", "page_building.html#autotoc_md97", null ],
        [ "Configuring in Batch Mode", "page_building.html#autotoc_md98", null ],
        [ "Re-Configuring", "page_building.html#autotoc_md99", null ],
        [ "Building a Distributable Package", "page_building.html#autotoc_md100", null ],
        [ "Details of CMake Visual Studio Generators", "page_building.html#autotoc_md101", null ],
        [ "Using Ninja For Better Error Messages, Faster Builds, and Proper Incremental Builds", "page_building.html#sec_ninja", [
          [ "Using Ninja With Pre-7.0 SDK", "page_building.html#autotoc_md102", null ]
        ] ],
        [ "Using MSBuild For Slightly Better Error Messages And Faster Builds", "page_building.html#autotoc_md103", null ],
        [ "Using Unix Makefiles On Windows For Parallel Builds", "page_building.html#autotoc_md104", null ]
      ] ],
      [ "Building the Qt DrGUI extension", "page_building.html#sec_drgui", null ]
    ] ],
    [ "Testing", "page_test_suite.html", [
      [ "Automated Test Machines", "page_test_suite.html#autotoc_md287", [
        [ "Continuous Integration (CI) via Github Actions", "page_test_suite.html#autotoc_md288", null ],
        [ "CI Job Auto-Cancellation", "page_test_suite.html#autotoc_md289", null ],
        [ "CI for AArch64 & AArch32", "page_test_suite.html#autotoc_md290", null ],
        [ "CI Tree Closures", "page_test_suite.html#autotoc_md291", null ],
        [ "Trybots", "page_test_suite.html#autotoc_md292", null ],
        [ "Debugging Tests on Github Actions Runner", "page_test_suite.html#autotoc_md293", null ]
      ] ],
      [ "Regression Test Suite", "page_test_suite.html#autotoc_md294", [
        [ "Test Organization", "page_test_suite.html#autotoc_md295", null ],
        [ "Building and Running Tests", "page_test_suite.html#autotoc_md296", null ],
        [ "Testing AArchXX", "page_test_suite.html#autotoc_md297", null ],
        [ "Test Output", "page_test_suite.html#autotoc_md298", null ],
        [ "Pre-Commit Test Suite", "page_test_suite.html#autotoc_md299", null ],
        [ "Cross-Compilation and Android Testing", "page_test_suite.html#autotoc_md300", null ],
        [ "Pre-Commit Test Suite Over Ssh", "page_test_suite.html#autotoc_md301", null ],
        [ "Test Failures", "page_test_suite.html#autotoc_md302", null ],
        [ "Missing Tests", "page_test_suite.html#autotoc_md303", null ]
      ] ],
      [ "Adding New Tests", "page_test_suite.html#autotoc_md304", null ]
    ] ],
    [ "Profiling DynamoRIO and Clients", "page_profiling.html", [
      [ "Linux", "page_profiling.html#autotoc_md241", [
        [ "DynamoRIO PC self-sampling", "page_profiling.html#autotoc_md242", null ],
        [ "External sampling tools", "page_profiling.html#autotoc_md243", [
          [ "oprofile", "page_profiling.html#autotoc_md244", null ],
          [ "perf", "page_profiling.html#autotoc_md245", null ]
        ] ]
      ] ],
      [ "Windows", "page_profiling.html#autotoc_md246", null ],
      [ "Cross-platform -prof_pcs", "page_profiling.html#autotoc_md247", null ]
    ] ],
    [ "Academic Publications", "page_publications.html", null ],
    [ "Design Documents", "page_design_docs.html", {% include_relative page_design_docs.js %} ]
],